/*
 * this is the playlist editor. it's a listbox and a few buttons, editable
 * with dlgedit
 * the listbox has been made to actually drag an item when the user keeps
 * the left mousebutton down while it moves - lvoge@cs.vu.nl
 */
#include <qfiledlg.h>
#include <qtstream.h>
#include "plDlg.h"

#define Inherited plDlgData

plDlg::plDlg(QWidget* parent, const char* name)	: Inherited( parent, name )
{
	setMinimumSize(size());
	setMaximumSize(size());
	setCaption("Xamp playlist editor");
	
        fileDialog = new QFileDialog(".", "*.mp*", NULL, "fileDialog", true);
        fileDialog->hide();
	connect(listEditor, SIGNAL(selected(int)), SIGNAL(seek_list()));
}

void plDlg::setList(QStrList *l) {
	listEditor->clear();
	listEditor->insertStrList(l);
}

void plDlg::getList(QStrList *l) {
	l->clear();
	for (int i = 0; i < listEditor->count(); i++)
	  l->append(listEditor->text(i));
	if (listEditor->currentItem() != -1)
	  l->at(listEditor->currentItem());
}

void plDlg::delete_clicked() {
	if (listEditor->currentItem() != -1)
	  listEditor->removeItem(listEditor->currentItem());
}

void plDlg::new_clicked() {
	fileDialog->show();
	if (!fileDialog->selectedFile())
	  return;
	if (fileDialog->selectedFile() == "*") {
		// read whole directory
	} else
	  listEditor->insertItem(fileDialog->selectedFile(), listEditor->currentItem() + 1);
	fileDialog->hide();
}

void plDlg::close_clicked() {
	emit fetch_list();
	fileDialog->hide();
	hide();
}

void plDlg::load_clicked() {
        QString infile = QFileDialog::getOpenFileName(0, "*.lst", this);
	if (infile.isEmpty())
	  return;
	QFile f(infile);
	f.open(IO_ReadOnly);
	QTextStream s(&f);
	QString t;
	QStrList tlist;
	t = s.readLine();
	if (!strcmp(t,"[Xamp playlist]"))
	  {
		  while (!s.eof())
		    {
			    t = s.readLine();
			    if (t.length() > 0)
				tlist.append(t);
		    }
	  }
	setList(&tlist);
	f.close();
}

void plDlg::save_clicked() {
	QString outfile( QFileDialog::getSaveFileName(0, "*.lst", this));
	if (!outfile.isNull())
	  {
		  QFile f(outfile);
		  f.open(IO_WriteOnly);
		  QTextStream s(&f);
		  s << "[Xamp playlist]" << '\n';
		  for (int i = 0; i < listEditor->count(); i++)
		      s << listEditor->text(i) << '\n';
		  f.close();
	  }
}

plDlg::~plDlg() {
	delete fileDialog;
}
